package eu.etaxonomy.taxeditor.prototype2.controller;

import org.eclipse.jface.action.Action;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.prototype2.Activator;

/**
 * Commit any changes to this taxon to the CDM
 * 
 * @author p.ciardelli
 *
 */
public class ActionSaveTaxon extends Action {
	Taxon taxon;
	
	public ActionSaveTaxon(Taxon taxon) {
		this.taxon = taxon;
	}
	
	public void run() {
		
		// If this is a new taxon, add it to the recent names list;
		//  if it is already in the tree, remove then re-add it
		//  to force a re-sort
		if (!Activator.getDefault().getObservableTaxonTreeList().contains(taxon)) {
			Activator.getDefault().getObservableRecentNamesList().add(0, taxon);
		} else {
			Activator.getDefault().getObservableTaxonTreeList().remove(taxon);
		}			
		Activator.getDefault().getObservableTaxonTreeList().add(taxon);

		// Save the taxon to the CDM
		Activator.getDefault().getCdmApp().getTaxonService().saveTaxon(taxon);
		
		// Notify taxon listeners in case name has been updated 
		taxon.firePropertyChange("name", null, null);
	}
}