package eu.etaxonomy.taxeditor.prototype2.view.nameviewersupport;

import org.eclipse.swt.SWT;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.DropTargetAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;

import eu.etaxonomy.cdm.model.name.HomotypicalGroup;
import eu.etaxonomy.cdm.model.taxon.Synonym;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.prototype2.controller.TaxonTransfer;
import eu.etaxonomy.taxeditor.prototype2.view.NameEditorView;

public class GroupComposite extends Composite {
	
	Taxon taxon;
	Rectangle rectangle;
	HomotypicalGroup homotypicalGroup;
	boolean acceptedGroup;
	private NameEditorView nameEditorView;
	
	public void setTaxon(Taxon taxon) {
		this.taxon = taxon;
	}
	
	public GroupComposite(Composite parent) {
		super(parent, SWT.NONE);
		
		// Graphic layout of composite
		GridLayout gridLayout = new GridLayout();
		gridLayout.verticalSpacing = 0;
		gridLayout.marginHeight = 3;
		this.setLayout(gridLayout);
		this.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false));
		this.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
					
//		this.addListener(SWT.Resize, new Listener() {
//			public void handleEvent(Event event) {
//				GC gc = new GC(GroupComposite.this);
//				rectangle = GroupComposite.this.getClientArea();
//				gc.setForeground(Display.getDefault().getSystemColor(SWT.COLOR_BLACK));
//				gc.drawRectangle(rectangle.x, rectangle.y, rectangle.width - 1, rectangle.height - 1);
//				System.out.println(rectangle.height);
//			}
//		});		
		
		// Drop functionality
		Transfer[] types = new Transfer[] {TaxonTransfer.getInstance()};
		int operations = DND.DROP_MOVE | DND.DROP_COPY | DND.DROP_DEFAULT;
		DropTarget target = new DropTarget(this, operations);
		target.setTransfer(types);
		target.addDropListener(new DropTargetAdapter() {
						
			public void dragEnter(DropTargetEvent event) {
				
				
				
//				for (Control child : GroupComposite.this.getChildren()) {
//					if (child.getClass() != NameComposite.class) continue;
////					System.out.println(child.getClass() + " " + event.data.getClass());
//					
//					if (((NameComposite) child).getName() == TaxonTransfer.getInstance().getTaxon().getName()) {
//						event.detail = DND.DROP_NONE;
//						return;
//					}
//				}
				
//				if (((NameComposite) event.widget).getParent() == GroupComposite.this)
//					event.detail = DND.DROP_NONE;
//				rectangle = GroupComposite.this.getClientArea();
//				GC gc = new GC(GroupComposite.this);
//				rectangle = GroupComposite.this.getClientArea();
//				gc.setForeground(Display.getDefault().getSystemColor(SWT.COLOR_BLACK));
//				gc.drawRectangle(rectangle.x, rectangle.y, rectangle.width - 1, rectangle.height - 1);
				
//				rectangle.draw(Display.getDefault().getSystemColor
//						(SWT.COLOR_BLACK));
			}
			
			public void dragLeave(DropTargetEvent event) {
//				rectangle.draw(Display.getDefault().getSystemColor
//						(SWT.COLOR_GRAY));
			}
			
			public void drop(DropTargetEvent event) {
				Synonym synonym = (Synonym) event.data; 
				
				GroupComposite dropTargetComposite = 
					(GroupComposite) ((DropTarget) 
							event.getSource()).getControl();
				
				new NameComposite(dropTargetComposite, synonym, taxon).
						setNameEditorView(dropTargetComposite.getNameEditorView());
			}
		});
	}
	
	public void drawRect() {
		GC gc = new GC(this);
		Rectangle rect = this.getClientArea();
		gc.setForeground(Display.getDefault().getSystemColor(SWT.COLOR_GREEN));
		gc.drawRectangle(rect.x, rect.y, rect.width - 2, rect.height - 2);		
	}

	public HomotypicalGroup getHomotypicalGroup() {
		return homotypicalGroup;
	}

	public void setHomotypicalGroup(HomotypicalGroup homotypicalGroup) {
		this.homotypicalGroup = homotypicalGroup;
	}
	
	public boolean isAcceptedGroup() {
		return acceptedGroup;
	}
	
	public void setAcceptedGroup(boolean acceptedGroup) {
		this.acceptedGroup = acceptedGroup;
	}

	public void setNameEditorView(NameEditorView nameEditorView) {
		this.nameEditorView = nameEditorView;
	}
	
	public NameEditorView getNameEditorView() {
		return nameEditorView;
	}
	
}
