package eu.etaxonomy.taxeditor.prototype2.view.nameviewersupport;

import org.eclipse.jface.text.rules.ICharacterScanner;
import org.eclipse.jface.text.rules.IPredicateRule;
import org.eclipse.jface.text.rules.IToken;
import org.eclipse.jface.text.rules.IWordDetector;
import org.eclipse.jface.text.rules.RuleBasedPartitionScanner;
import org.eclipse.jface.text.rules.Token;
import org.eclipse.jface.text.rules.WordRule;

public class NamePartitionScanner_ extends RuleBasedPartitionScanner {
	public final static String SINGLE_WORD = "__single_word";
	public final static String[] PARTITION_TYPES = {SINGLE_WORD}; 
	
	public NamePartitionScanner_()
		{
		super();
				
		IPredicateRule[] rules = new IPredicateRule[1];
		
		IToken word = new Token(SINGLE_WORD);
		rules[0] = new WordPredicateRule (word);
		
		setPredicateRules(rules);
	}
	
	class WordPredicateRule extends WordRule implements IPredicateRule {

		private IToken fSuccessToken;
		
		public WordPredicateRule(IToken successToken) {
			super(new IWordDetector() {
				
				public boolean isWordPart(char c) {
					return !Character.isWhitespace(c);
				}
	
				public boolean isWordStart(char c) {
					return !Character.isWhitespace(c);
				}
				
			});
			this.fSuccessToken = successToken;
		}

		public IToken evaluate(ICharacterScanner scanner, boolean resume) {
			return super.evaluate(scanner);
		}
		
		public IToken evaluate(ICharacterScanner scanner) {
			
			StringBuffer fBuffer = new StringBuffer();
			
			int c = scanner.read();
			if (c != ICharacterScanner.EOF && fDetector.isWordStart((char) c)) {
				if (fColumn == UNDEFINED || (fColumn == scanner.getColumn() - 1)) {

					fBuffer.setLength(0);
					do {
						fBuffer.append((char) c);
						c= scanner.read();
					} while (c != ICharacterScanner.EOF && fDetector.isWordPart((char) c));
					scanner.unread();

					return fSuccessToken;
				}
			}

			scanner.unread();
			return Token.UNDEFINED;
		}
		

		public IToken getSuccessToken() {
			return fSuccessToken;
		}
		
	}
}
