package eu.etaxonomy.taxeditor;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

import eu.etaxonomy.taxeditor.navigation.FavoritesView;
import eu.etaxonomy.taxeditor.navigation.RecentNamesView;
import eu.etaxonomy.taxeditor.navigation.SearchView;
import eu.etaxonomy.taxeditor.navigation.TaxonomicTreeView;

public class SideBySidePerspective implements IPerspectiveFactory {

	/*
	 * To remember the user's layout and window sizes for the next time they 
	 *  start your application, add configurer.setSaveAndRestore(true); to the 
	 *  initialize() method of WorkbenchAdvisor.
	 */
	
	public static final String ID = "eu.etaxonomy.taxeditor.perspective.sidebyside";
	
	public void createInitialLayout(IPageLayout layout) {
		String editorArea = layout.getEditorArea();
		
		// Note: plug-in org.eclipse.ui.ide necessary for 
		//  IPageLayout.ID_PROBLEM_VIEW ("org.eclipse.ui.views.ProblemView") to run
//		layout.addView(IPageLayout.ID_PROBLEM_VIEW, IPageLayout.BOTTOM, 0.8f, editorArea);		
		
		IFolderLayout folderLayoutLeft = layout.createFolder("leftfolder", IPageLayout.LEFT, 0.3f, editorArea);
		folderLayoutLeft.addView(TaxonomicTreeView.ID);
//		folderLayoutLeft.addView(SearchView.ID);
		
		IFolderLayout folderLayoutBottomLeft = layout.createFolder("bottomleftfolder", IPageLayout.BOTTOM, 0.75f, "leftfolder");
		folderLayoutBottomLeft.addView(RecentNamesView.ID);
//		folderLayoutBottomLeft.addView(FavoritesView.ID);
		
		layout.getViewLayout(TaxonomicTreeView.ID).setCloseable(false);	
	}
}
