/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy 
 * http://www.e-taxonomy.eu
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.actions.cdm;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.Action;

import eu.etaxonomy.cdm.model.name.NameRelationshipType;
import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.taxeditor.ITaxEditorConstants;
import eu.etaxonomy.taxeditor.TaxEditorPlugin;

/**
 * @author p.ciardelli
 * @created 05.06.2008
 * @version 1.0
 */
public class CreateNameRelationAction extends Action {
	private static final Logger logger = Logger
			.getLogger(CreateNameRelationAction.class);

	private TaxonNameBase fromName;
	private NameRelationshipType type;
	private TaxonNameBase toName;

	public CreateNameRelationAction(TaxonNameBase fromName,
			NameRelationshipType type, TaxonNameBase toName) {
		this.fromName = fromName;
		this.type = type;
		this.toName = toName;
	}

	public void run() {
		toName.addRelationshipFromName(fromName, type, null);
		logger.warn("firing property change");
		firePropertyChange(ITaxEditorConstants.NAMERELATION, "old", "new");
	}
}
