/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy 
 * http://www.e-taxonomy.eu
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.actions.cdm;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.Action;

import eu.etaxonomy.cdm.model.taxon.Synonym;
import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.ITaxEditorConstants;
import eu.etaxonomy.taxeditor.TaxEditorPlugin;

/**
 * @author p.ciardelli
 * @created 22.05.2008
 * @version 1.0
 */
public class DeleteSynonymFromAcceptedTaxaAction extends Action {
	private static final Logger logger = Logger
			.getLogger(DeleteSynonymFromAcceptedTaxaAction.class);

	private Synonym synonym;

	public DeleteSynonymFromAcceptedTaxaAction(Synonym synonym) {
		super();
		this.synonym = synonym;
	}

	public void run() {
		for (Taxon acceptedTaxon : synonym.getAcceptedTaxa()) {
			acceptedTaxon.removeSynonym(synonym);
//			TaxEditorPlugin.getDefault().getCdmApp().getTaxonService().removeTaxon(
//					synonym);
		}

		firePropertyChange(ITaxEditorConstants.SYNONYM, null, null);
	}

	public Synonym getSynonym() {
		return synonym;
	}
}
