/**
 * Copyright (C) 2007 EDIT
 * European Distributed Institute of Taxonomy 
 * http://www.e-taxonomy.eu
 * 
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.navigation;

import org.apache.log4j.Logger;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.ViewPart;

import com.swtdesigner.SWTResourceManager;

/**
 * The left navigation pane.
 * 
 * @author p.ciardelli
 * @created 27.05.2008
 * @version 1.0
 */
public class SearchView extends ViewPart {
	private static final Logger logger = Logger.getLogger(SearchView.class);
	
	private Text searchText;
	private Composite searchComposite = null;
	public static final String ID = "eu.etaxonomy.taxeditor.navigation.searchview"; //$NON-NLS-1$
	
	/**
	 * Create contents of the view part
	 * @param parent
	 */
	@Override
	public void createPartControl(Composite parent) {
		
		parent.setLayout(new FillLayout());

		searchComposite = new Composite(parent, SWT.NONE);
		searchComposite.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		final GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		searchComposite.setLayout(gridLayout);
		
		searchText = new Text(searchComposite, SWT.BORDER);
		searchText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
		searchText.setForeground(SWTResourceManager.getColor(192, 192, 192));
		searchText.setText("Use \"*\" for wildcard searching");
		final GridData gd_useForText = new GridData(SWT.FILL, SWT.CENTER, true, false);
		searchText.setLayoutData(gd_useForText);
		searchText.addFocusListener(new FocusListener() {

			public void focusGained(FocusEvent e) {
				searchText.setForeground(SWTResourceManager.getColor(0,0,0));
				searchText.setText("");
			}

			public void focusLost(FocusEvent e) {
				if (searchText.getText() == "") {
					searchText.setForeground(SWTResourceManager.getColor(192, 192, 192));
					searchText.setText("Use \"*\" for wildcard searching");					
				}
				
			}
			
		});

		final Button searchButton = new Button(searchComposite, SWT.NONE);
		searchButton.setText("Search");

		// TEMPORARY PENDING IMPLEMENTATION - Disable visible fields
		searchComposite.setEnabled(false);
		searchButton.setEnabled(false);
		
		createActions();
		initializeToolBar();
		initializeMenu();
	}
	
	private void createActions() {
		// Create the actions
	}

	/**
	 * Initialize the toolbar
	 */
	private void initializeToolBar() {
		IToolBarManager toolbarManager = getViewSite().getActionBars()
				.getToolBarManager();
	}

	/**
	 * Initialize the menu
	 */
	private void initializeMenu() {
		IMenuManager menuManager = getViewSite().getActionBars()
				.getMenuManager();
	}

	@Override
	public void setFocus() {
		// Set the focus
	}	
}
