/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.operations;

import org.apache.log4j.Logger;
import org.eclipse.core.commands.operations.AbstractOperation;
import org.eclipse.core.commands.operations.IUndoContext;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.UiUtil;
import eu.etaxonomy.taxeditor.editor.name.TaxonNameEditor;

/**
 * @author p.ciardelli
 * @created 14.01.2009
 * @version 1.0
 */
public abstract class AbstractEditorOperation extends AbstractOperation {
	private static final Logger logger = Logger
			.getLogger(AbstractEditorOperation.class);
	
	protected Taxon taxon;

	public AbstractEditorOperation(String label, IUndoContext undoContext,
			Taxon taxon) {
		super(label);
		addContext(undoContext);
		
		this.taxon = taxon;
	}
	
	protected IStatus redrawOpenEditor() {
		
		// Redraw editor if exists
		TaxonNameEditor editor = UiUtil.getTaxonNameEditor(taxon);
		if(editor == null || editor.redraw()){
			
			// Mark editor as changed and unsaved
			editor.setDirty();
			
			return Status.OK_STATUS;	
		}	
		return Status.CANCEL_STATUS;
	}
}
